package tomracer.neural;


public class CTRNNNeuron extends Neuron {
	static {
//		CellFactory.addCellClass(Consts.CTRNNNeuron_GENEID,
//				CTRNNNeuron.class);
	}
	static public boolean showMemory = false;
	private double memory;
	private double learn_rate;
	private double bias;
	public static double override_rate=0;
	public static boolean switched_off = false;
	public CTRNNNeuron(double memory, double learn_rate, double bias) {
		this.memory = (memory);
		this.learn_rate = learn_rate;
		this.bias = bias;
	}


	public double calcOutput(double input) {
		if (override_rate!=0)
			learn_rate=override_rate;
		if (Double.isNaN(memory)) {
			System.out.println("befmemNan: lr:"+learn_rate+" mem:"+memory+" in:"+input);
			System.exit(1);
		}
//		System.out.println("memNan: lr:"+learn_rate+" mem:"+memory+" in:"+input+ " expr:"+((1/learn_rate) *(-memory)));
		if (!switched_off) {
			memory = ((1.0-(1.0/learn_rate)) *memory) + ((1.0/learn_rate)*input);	
		}
		if (memory > 30)
			memory = 20;
		if (memory < -30)
			memory = -30;
		if (Double.isNaN(memory)) {
			System.out.println("memNan: lr:"+learn_rate+" mem:"+memory+" in:"+input+ " expr:"+((1/learn_rate) *(-memory)));
			System.exit(1);
		}
		double out =1 / (1 + (Math.exp(-1 * (memory+bias))));
		if (Double.isNaN(out)) {
			System.out.println("outNan:");
			System.exit(1);
		}

		if (showMemory)
			System.out.println("this:"+this+" memory:"+memory);
		return out;
	}

	public String toString() {
		return (("CTRNNNeuron memory:"+memory+"  (learn_rate:") + (learn_rate));
	}
	
	public static void main(String[] args) {
		CTRNNNeuron n = new CTRNNNeuron(0,2000,0);
		for (int i=0;i<10000;i++) {
				n.calcOutput(i<5000? 1:0);
			System.out.println(n);
		}
	}

	public void setMemory(double memory) {
		this.memory = memory;
	}

	public double getMemory() {
		return memory;
	}
}
