/* Generated by EPP 1.1.5 (by 1.1.5 (by lisp-epp1.1.1)) */

package tomracer.neural;



import java.io.Serializable;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.Vector;


public class NeuralNetwork implements Serializable {
	private Vector neurons;
	private List<InputNeuron> inputNeurons;
	private List<OutputNeuron> outputNeurons;
	private List<Neuron> hiddenNeurons;

	public static int COMPRES = 3;
	public double homeradius = 0;
	public NeuralNetwork() {
		neurons = (new Vector());
		inputNeurons = new ArrayList<InputNeuron>();
		outputNeurons = new ArrayList<OutputNeuron>();
		hiddenNeurons = new ArrayList<Neuron>();
	}

	public void addNeuron(Cell cell) {
		neurons.addElement(cell);
	}
	
	public void addInputNeuron(InputNeuron neuron) {
		addNeuron(neuron);
		inputNeurons.add(neuron);
	}
	public void addHiddenNeuron(Neuron neuron) {
		addNeuron(neuron);
		hiddenNeurons.add(neuron);
	}

	
	public double[] activate(double[] input, int cycles) {

		if (inputNeurons.size()!= input.length) {
			System.err.println("input neuron size:"+inputNeurons.size());
			System.err.println("warning: input sizes disagree");
		}
		for (int i=0;i<inputNeurons.size();i++) {
			inputNeurons.get(i).setInput(input[i]);
		}
		for (int i=0;i<cycles;i++)
			this.runFeedForwardCycle();
//		for (int i=0;i<cycles;i++) {
//			this.runCycle();
//		}
		double[] result = new double[outputNeurons.size()];
		for (int i=0; i<result.length;i++) {
			result[i] = outputNeurons.get(i).getLastOutput();
		}
		return result;
	}
	
	public void addOutputNeuron(OutputNeuron neuron) {
		addNeuron(neuron);
		outputNeurons.add(neuron);
	}
	
	public Cell getNeuron(int i) {
		if (neurons.size()<=i || i<0)
			return null;
		return (/* cast */(Cell) (neurons.elementAt(i)));
	}

	public int neuronCount() {
		return neurons.size();
	}

	public void runCycle() {
		for (int i = 0; (i) < (neuronCount()); i++) {
			(getNeuron(i)).processInputs();
		}
		for (int i = 0; (i) < (neuronCount()); i++) {
			(getNeuron(i)).fireOutputs();
		}

	}

	public void runFeedForwardCycle() {
		for (int i=0;i<inputNeurons.size();i++) {
			inputNeurons.get(i).processInputs();
			inputNeurons.get(i).fireOutputs();
		}
		for (int i=0;i<hiddenNeurons.size();i++) {
			hiddenNeurons.get(i).processInputs();
			hiddenNeurons.get(i).fireOutputs();
		}
		for (int i=0;i<outputNeurons.size();i++) {
			outputNeurons.get(i).processInputs();
			outputNeurons.get(i).fireOutputs();
		}

	}
	
	public double getAvgMemoryNeuronLevel() {
		double avgmem=0;
		for (int i = 0; (i) < (neuronCount()); i++) {
			Cell c = getNeuron(i);
			if (c instanceof PIMemoryNeuron) {
				PIMemoryNeuron memn = (PIMemoryNeuron) c;
				avgmem += Math.abs(memn.getMemory());
			}
		}
		avgmem /= (double)neuronCount();
		return avgmem;
	}
	public double getAvgCTRNNNeuronLevel() {
		double avgmem=0;
		for (int i = 0; (i) < (neuronCount()); i++) {
			Cell c = getNeuron(i);
			if (c instanceof CTRNNNeuron) {
				CTRNNNeuron memn = (CTRNNNeuron) c;
				avgmem += Math.abs(memn.getMemory());
			}
		}
		avgmem /= (double)neuronCount();
		return avgmem;
	}
	

	
	public double getAvgConnections() {
		int numConnections = 0;
		for (int i = 0; (i) < (neuronCount()); i++) {
			numConnections += ((getNeuron(i)).connectionCount());
		}

		return ((/* cast */(double) (numConnections)))
				/ ((/* cast */(double) (neuronCount())));
	}
//	public static NeuralNetwork decodeGenome(Genome g, PIEntity owner)  {
// 
//		Genome.GenomeReader gr = g.getGenomeReader();
//		int res = COMPRES;
//		NeuralNetwork nn = new NeuralNetwork();
//		//owner.setBrain(nn);
//		
//		//double bias = gr.getNextScaled()*2-1;
//		//double a = gr.getNextScaled()*3;
//		//boolean useSigmoid = gr.getNextScaled()>0.5;
//
/////		PIDifferentialCompassSensor diffCompass = new PIDifferentialCompassSensor(owner);
//		nn.homeradius = gr.getNextScaled()*80.0;
//		
//		//nn.homeradius = 40;
//		
//		PICompassSensor compass = new PICompassSensor(owner,res,0,0,false);
//		nn.addNeuron(compass);
//		double interval = 360.0/((double)res);
//////		PIMemoryNeuron[] mems = new PIMemoryNeuron[res];
//		CTRNNNeuron[] mems = new CTRNNNeuron[res];
//		PITurnMotor turnLeft = new PITurnMotor(-20,owner);
//		PITurnMotor turnRight = new PITurnMotor(20,owner);
//
//		
//		nn.addNeuron(turnLeft);
//		nn.addNeuron(turnRight);
//
/////		PIMemoryNeuron dLeftMem = new PIMemoryNeuron(0,0);
//
/////		PIMemoryNeuron dRightMem = new PIMemoryNeuron(0,0);
//		
/////		nn.addNeuron(dLeftMem);
/////		nn.addNeuron(dRightMem);
/////	nn.addNeuron(diffCompass);
//		
/////		diffCompass.addConnection(new CellConnection(gr.getNextScaled()*10.0,dLeftMem));
/////		diffCompass.addConnection(new CellConnection(gr.getNextScaled()*10.0,dRightMem));
//
//		
/////		dLeftMem.addConnection(new CellConnection(gr.getNextScaled()*10.0-5.0,turnLeft));
/////		dRightMem.addConnection(new CellConnection(gr.getNextScaled()*10.0-5.0,turnLeft));
/////		dLeftMem.addConnection(new CellConnection(gr.getNextScaled()*10.0-5.0,turnRight));
/////		dRightMem.addConnection(new CellConnection(gr.getNextScaled()*10.0-5.0,turnRight));
//
//		/*for (int i=0;i<res;i++) {
//			nn.addNeuron(new PIMemoryNeuron(0,0));
//		}
//		for (int i=0;i<res*res;i++) {
//			nn.addNeuron(new SigmoidNeuron(gr.getNextScaled()*10.0-5.0,gr.getNextScaled()*10.0-5.0));
//		}
//		for (int i=0;i<nn.neuronCount();i++) {
//			for (int j=0;j<nn.neuronCount();j++){
//				nn.getNeuron(i).addConnection(new CellConnection(gr.getNextScaled()*4.0-2.0,(ProcessingUnit)nn.getNeuron(j)));
//			}
//		}*/
//
//		//double memory = ((((double) (gr.getNext()))) / (Consts.NEURON_GENE_DIVISOR));
//		double learn_rate = Math.pow(10,gr.getNextScaled() * 40.0 - 20.0);
//		double bias = gr.getNextScaled() * 4.0 -2.0;
//		double recurrent = gr.getNextScaled();
//		double compassToMem = gr.getNextScaled()*10.0-5.0;
//		
//		for (int i = 0; i <res; i++) {
//			mems[i] = new CTRNNNeuron(0,learn_rate,bias);
//			nn.addNeuron(mems[i]);
//			compass.addConnection(new CellConnection(compassToMem,mems[i]));
//			mems[i].addConnection(new CellConnection(recurrent,mems[i]));
//		}
//
///*		for (int i = 0; i <res; i++) {
//			for (int j=0;j<res;j++) {
//				double compass2Mem2 = gr.getNextScaled()*1.0-0.5; 
//			  compass.addConnection(new CellConnection(compass2Mem2,mems[i]));
//			}
//		}*/
//
////		double [] memToMem = new double[res];
////		for (int i=0;i<res;i++) 
////		  memToMem[i] = gr.getNextScaled()*0.2-0.1;				
//
//		
//		
//		
////		for (int i = 0; i <res; i++) {
////		for (int j=0;j<res;j++){
////			if (i!=j) {
////				mems[i].addConnection(new CellConnection(memToMem[(j-i+res)%res],mems[j]));
////			}
////		}
////		}
///*		for (int i=0;i<reslj++){
//			mem2sigs
//		}*/
//		double sigBias = gr.getNextScaled()*10.0-5.0;
//		double sigA = gr.getNextScaled()*10.0+0.2;
//		double sig2turn = gr.getNextScaled()*10-5.0+0.2;
//		boolean whichway = gr.getNextScaled() >0.5;
//
//		double comp2sig = gr.getNextScaled()*10.0-5.0;
//
//		for (int i = 0; i <res; i++) {
//
//
//			double angle = interval*i;
//			SigmoidNeuron sLeft = new SigmoidNeuron(sigA,sigBias);
//			SigmoidNeuron sRight = new SigmoidNeuron(sigA,sigBias);
//			nn.addNeuron(sLeft);
//			nn.addNeuron(sRight);
//			sLeft.addConnection(new CellConnection(sig2turn,turnLeft));
//			sRight.addConnection(new CellConnection(sig2turn,turnRight));
//			sLeft.addConnection(new CellConnection(-sig2turn,turnRight));
//			sRight.addConnection(new CellConnection(-sig2turn,turnLeft));
//
//			compass.addConnection(new CellConnection(comp2sig,sLeft));
//			for (int j=1;j<res;j++)
//				compass.addConnection(new CellConnection(0,null));
//			compass.addConnection(new CellConnection(comp2sig,sRight));
//			for (int j=0;j<res;j++) {
//				double cAngle = interval*j;
//				double relAngle = PIController.getRelAngle(angle,cAngle);
//				if (relAngle>0&&relAngle<180) {
//					mems[j].addConnection(new CellConnection(gr.getNextScaled()*10.0-5.0,whichway ? sLeft:sRight));
//				} else
//				if (relAngle<0&&relAngle>-180) {
//					mems[j].addConnection(new CellConnection(gr.getNextScaled()*10.0-5.0,whichway ? sRight:sLeft));
//				}
//			}
//		}
//        return nn;
//     }

	public List<InputNeuron> getInputNeurons() {
		return inputNeurons;
	}
	
	public List<Neuron> getHiddenNeurons() {
		return hiddenNeurons;
	}
	
	public List<OutputNeuron> getOutputNeurons() {
		return outputNeurons;
	}
	
	public String toString() {
		String out = (("NeuralNetwork: \n ConnsPerNeuron:") + (getAvgConnections())+" homepoint:"+homeradius)
				+ ("\n");
		for (int i = 0; i < neuronCount(); i++) {
			Cell n = getNeuron(i);
			out += "" + i + ": " + n + "\n";
			if (n != null)
				for (int i2 = 0; (i2) < (n.connectionCount()); i2++) {
					out += "   " + n.getConnection(i2) + "\n";
				}
		}
		return out;
	}

	public void reset() {
		for (int i = 0; (i) < (neuronCount()); i++) {
			Cell c = getNeuron(i);
			if (c instanceof CTRNNNeuron) {
				CTRNNNeuron memn = (CTRNNNeuron) c;
				memn.setMemory(0);
				}
			if (c instanceof ProcessingUnit) {
				ProcessingUnit memn = (ProcessingUnit) c;
				memn.reset();
			}

		}
	}
}
